
void() bubble_bob;

/*
==============================================================================

PLAYER

==============================================================================
*/

$cd id1/models/player_4
$origin 0 -6 24
$base base		
$skin skin

// Idle

$frame Idle1

// Ready

$frame Ready1

// Walk

$frame Walk1 Walk2 Walk3 Walk4 Walk5 Walk6

// Run

$frame Run1 Run2 Run3 Run4 Run5 Run6 Run7 Run8

// Jump

$frame Jump1 Jump2 Jump3

// Swim

$frame Swim1 Swim2 Swim3 Swim4 Swim5 Swim6 Swim7 Swim8

// Attack

$frame AttackA1 AttackA2 AttackA3 AttackA4 AttackA5 AttackA6
$frame AttackB1 AttackB2 AttackB3 AttackB4 AttackB5 AttackB6
$frame AttackC1 AttackC2 AttackC3 AttackC4 AttackC5 AttackC6
$frame AttackD1 AttackD2 AttackD3 AttackD4 AttackD5 AttackD6

// Death

$frame Death1 Death2 Death3 Death4 Death5 Death6 Death7 Death8
$frame Death9 Death10 Death11 Death12
/*
$frame Pain1 Pain2 Pain3 Pain4 Pain5 Pain6


//
// running
//
$frame axrun1 axrun2 axrun3 axrun4 axrun5 axrun6

$frame rockrun1 rockrun2 rockrun3 rockrun4 rockrun5 rockrun6

//
// standing
//
$frame stand1 stand2 stand3 stand4 stand5

$frame axstnd1 axstnd2 axstnd3 axstnd4 axstnd5 axstnd6
$frame axstnd7 axstnd8 axstnd9 axstnd10 axstnd11 axstnd12


//
// pain
//
$frame axpain1 axpain2 axpain3 axpain4 axpain5 axpain6

$frame pain1 pain2 pain3 pain4 pain5 pain6


//
// death
//

$frame axdeth1 axdeth2 axdeth3 axdeth4 axdeth5 axdeth6
$frame axdeth7 axdeth8 axdeth9

$frame deatha1 deatha2 deatha3 deatha4 deatha5 deatha6 deatha7 deatha8
$frame deatha9 deatha10 deatha11

$frame deathb1 deathb2 deathb3 deathb4 deathb5 deathb6 deathb7 deathb8
$frame deathb9

$frame deathc1 deathc2 deathc3 deathc4 deathc5 deathc6 deathc7 deathc8
$frame deathc9 deathc10 deathc11 deathc12 deathc13 deathc14 deathc15

$frame deathd1 deathd2 deathd3 deathd4 deathd5 deathd6 deathd7
$frame deathd8 deathd9

$frame deathe1 deathe2 deathe3 deathe4 deathe5 deathe6 deathe7
$frame deathe8 deathe9

//
// attacks
//
$frame nailatt1 nailatt2

$frame light1 light2

$frame rockatt1 rockatt2 rockatt3 rockatt4 rockatt5 rockatt6

$frame shotatt1 shotatt2 shotatt3 shotatt4 shotatt5 shotatt6

$frame axatt1 axatt2 axatt3 axatt4 axatt5 axatt6

$frame axattb1 axattb2 axattb3 axattb4 axattb5 axattb6

$frame axattc1 axattc2 axattc3 axattc4 axattc5 axattc6

$frame axattd1 axattd2 axattd3 axattd4 axattd5 axattd6
*/
/*
==============================================================================
PLAYER
==============================================================================
*/

void() player_walk;
void() player_run;
void() player_jump;
void() player_swim;

float  p_speed;

void()	player_stand1 = [	$Ready1,	player_stand1	]
{
	if (((self.weapon == IT_SHOTGUN) && (self.bulletclip == 0)))
		self.weaponframe = 8;
	else
		self.weaponframe = 0;

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
		self.walkframe=0;
		player_swim();
	    return;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
		self.walkframe=0;
		player_jump();
	    return;
	}

    else if (p_speed >= 125)
	{
		self.walkframe=0;
		player_run();
	    return;
	}

	else if (p_speed >= 1)
	{
		self.walkframe=0;
		player_walk();
	    return;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }
};

void()  player_walk =
{
	if (((self.weapon == IT_SHOTGUN) && (self.bulletclip == 0)))
		self.weaponframe = 8;
	else
		self.weaponframe = 0;
		
    self.nextthink = time + 0.1;
    self.think = player_walk;
    
    p_speed = vlen (self.velocity);

    if (p_speed == 0)
	{
		self.walkframe=0;
		player_stand1();
		return;
	}

	else if (self.waterlevel > 1)
    {
		self.walkframe=0;
		player_swim();
	    return;
    }
    
    else if (!(self.flags & FL_ONGROUND))
	{
		self.walkframe=0;
		player_jump();
	    return;
	}

    else if (p_speed >= 125)
	{
		self.walkframe=0;
		player_run();
	    return;
	}

	else 
    {
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
    }
	self.walkframe = self.walkframe + 1;
}

void()	player_run =
{
	if (((self.weapon == IT_SHOTGUN) && (self.bulletclip == 0)))
		self.weaponframe = 8;
	else
		self.weaponframe = 0;

    self.nextthink = time + 0.1;
    self.think = player_run;
    
    p_speed = vlen (self.velocity);

    if (p_speed == 0)
	{
		self.walkframe=0;
		player_stand1();
		return;
	}

	else if (self.waterlevel > 1)
    {
		self.walkframe=0;
		player_swim();
	    return;
    }
    
    else if (!(self.flags & FL_ONGROUND))
	{
		self.walkframe=0;
		player_jump();
	    return;
	}

	else if (p_speed < 125)
	{
		self.walkframe=0;
		player_walk();
	    return;
	}

	else
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
		self.nextthink = time + 0.07;
           		
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
    }

	self.walkframe = self.walkframe + 1;
};

void()  player_jump =
{
	if (((self.weapon == IT_SHOTGUN) && (self.bulletclip == 0)))
		self.weaponframe = 8;
	else
		self.weaponframe = 0;

    if (self.flags & FL_ONGROUND)
	{
		self.walkframe=0;
		player_walk();
		return;
	}

    if (self.walkframe >= 3)
		self.walkframe = 3;
	self.frame = $Jump1 + self.walkframe;
    
	self.walkframe = self.walkframe + 1;
}

void()  player_swim =
{
	if (((self.weapon == IT_SHOTGUN) && (self.bulletclip == 0)))
		self.weaponframe = 8;
	else
		self.weaponframe = 0;

    self.nextthink = time + 0.1;
    self.think = player_swim;
    
    if (self.waterlevel < 1)
	{
		self.walkframe=0;
		player_walk();
		return;
	}

	if (self.walkframe >= 7)
        self.walkframe = 0;
	self.frame = $Swim1 + self.walkframe;
    
	self.walkframe = self.walkframe + 1;
}

//============================================================================
// Weapon Change
//============================================================================

void()	player_changeup2;

void()	player_changeup =  {self.think = player_changeup2; self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 2\n");};
void()	player_changeup2 =	[$Run2, player_changeup3	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 8\n");};
void()	player_changeup3 =	[$Run2, player_changeup4	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 14\n");};
void()	player_changeup4 =	[$Run2, player_changeup5	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 20\n");};
void()	player_changeup5 =	[$Run2, player_changeup6	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 25\n");};
void()	player_changeup6 =	[$Run2, player_changeup7	] {self.nextthink = time + 0.03; W_SetCurrentWeapon();};
void()	player_changeup7 =	[$Run2, player_changeup8	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 25\n");WeaponName();};
void()	player_changeup8 =	[$Run2, player_changeup9	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 20\n");};
void()	player_changeup9 =	[$Run2, player_changeup10	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 14\n");};
void()	player_changeup10 =	[$Run2, player_changeup11	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 8\n");};
void()	player_changeup11 =	[$Run2, player_changeup12	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 2\n");};
void()	player_changeup12 =	[$Run2, player_run	] {self.nextthink = time + 0.03; stuffcmd(self,"cl_gunpitch 0\n");self.attack_finished = time;};

//============================================================================
// Knife
//============================================================================

void()	player_knife1 =	[$AttackA1, player_knife2	] {self.weaponframe=1;self.weaponmodel = "progs/v_axea.mdl";};
void()	player_knife2 =	[$AttackA2, player_knife3	] {self.weaponframe=2;};
void()	player_knife3 =	[$AttackA3, player_knife4	] {self.weaponframe=3;W_FireAxe();};
void()	player_knife4 =	[$AttackA4, player_knife5	] {self.weaponframe=4;};
void()	player_knife5 =	[$AttackA5, player_knife6	] {self.weaponframe=0;};
void()	player_knife6 =	[$AttackA6, player_run	] {self.nextthink = time + 0.07;self.weaponframe=0;self.weaponmodel = "progs/v_axe.mdl";};

void()	player_knifeb1 =	[$AttackB1, player_knifeb2	] {self.weaponframe=5;self.weaponmodel = "progs/v_axea.mdl";};
void()	player_knifeb2 =	[$AttackB2, player_knifeb3	] {self.weaponframe=6;};
void()	player_knifeb3 =	[$AttackB3, player_knifeb4	] {self.weaponframe=7;W_FireAxe();};
void()	player_knifeb4 =	[$AttackB4, player_knifeb5	] {self.weaponframe=8;};
void()	player_knifeb5 =	[$AttackB5, player_knifeb6	] {self.weaponframe=0;};
void()	player_knifeb6 =	[$AttackB6, player_run	] {self.weaponframe=0;self.weaponmodel = "progs/v_axe.mdl";};

void()	player_knifec1 =	[$AttackC1, player_knifec2	] {self.weaponframe=9;self.weaponmodel = "progs/v_axea.mdl";};
void()	player_knifec2 =	[$AttackC2, player_knifec3	] {self.weaponframe=10;};
void()	player_knifec3 =	[$AttackC3, player_knifec4	] {self.weaponframe=11;W_FireAxe();};
void()	player_knifec4 =	[$AttackC4, player_knifec5	] {self.weaponframe=12;};
void()	player_knifec5 =	[$AttackC5, player_knifec6	] {self.weaponframe=0;};
void()	player_knifec6 =	[$AttackC6, player_run	] {self.weaponframe=0;self.weaponmodel = "progs/v_axe.mdl";};

void()	player_knifed1 =	[$AttackD1, player_knifed2	] {self.weaponframe=1;self.weaponmodel = "progs/v_axea.mdl";};
void()	player_knifed2 =	[$AttackD2, player_knifed3	] {self.weaponframe=2;};
void()	player_knifed3 =	[$AttackD3, player_knifed4	] {self.weaponframe=3;W_FireAxe();};
void()	player_knifed4 =	[$AttackD4, player_knifed5	] {self.weaponframe=4;};
void()	player_knifed5 =	[$AttackD5, player_knifed6	] {self.weaponframe=0;};
void()	player_knifed6 =	[$AttackD6, player_run	] {self.weaponframe=0;self.weaponmodel = "progs/v_axe.mdl";};

//============================================================================
// Tekbow
//============================================================================

void()	player_arrow1;
void()	player_arrow1 =
{
    self.aflag = 1;
    self.ammoready = 0;
	self.weaponframe = self.weaponframe + 1;
 
    self.nextthink = time + 0.075;
    self.think = player_arrow1;

// View model Animation

	if (self.weaponframe == 1)
		sound (self, CHAN_WEAPON, "weapons/bow.wav", 1, ATTN_NORM);

	if (!self.button0)
	{
		if (self.weaponframe == 1)
		{	
			W_FireArrow (100);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 2)
		{	
			W_FireArrow (250);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 3)
		{	
			W_FireArrow (500);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 4)
		{	
			W_FireArrow (750);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 5)
		{	
			W_FireArrow (1000);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 6)
		{	
			W_FireArrow (1250);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 7)
		{	
			W_FireArrow (1500);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 8)
		{	
			W_FireArrow (1750);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
		if (self.weaponframe == 9)
		{	
			W_FireArrow (2500);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;

		}
		if (self.weaponframe == 10)
		{	
			W_FireArrow (2500);
			self.weaponframe = 10;
			self.weaponframe = self.weaponframe + 1;
			self.nextthink = time + 0.25;
		}
    }
	if (self.weaponframe ==10)
		self.weaponframe = 9;

	if (self.weaponframe == 12)
		self.nextthink = time + 0.1;

	if (self.weaponframe >= 14)
	{
        self.aflag=0;
        self.ammoready=1;
		self.attack_finished = time;
		if (self.zoomtoggle == 1)
			W_SetAmmoOnly();
		else
            W_SetCurrentAmmo();
		UpdateAmmoCounts(self);
        player_run();
		return;
	}

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }

};

//============================================================================
// Pistol
//============================================================================

void()	player_pistol1;

void()	player_pistol1 =
{
	self.weaponframe = self.weaponframe + 1;
	self.nextthink = time + 0.05;
	self.think = player_pistol1;

    if (self.weaponframe == 1)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 2)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 3)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    	
	if (self.weaponframe >= 4)
	{
		self.attack_finished = time;
		player_run ();
		return;
    }
    
// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }

}

void()	player_lpistol1;

void()	player_lpistol1 =
{
    self.weaponframe = 5;   
	self.weaponframe = self.weaponframe + 1;
	self.nextthink = time + 0.05;

    if (self.weaponframe == 5)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 6)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 7)
    	self.effects = self.effects | EF_MUZZLEFLASH;

	if (self.weaponframe >= 8)
	{
		self.attack_finished = time;
		player_run ();
		return;
    }

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
        
    }

}

void()	player_rpistol1 =	[$AttackA1, player_rpistol2	] {self.nextthink = time + 0.075; self.weaponframe=8;};
void()	player_rpistol2 =	[$AttackA2, player_rpistol3	] {self.nextthink = time + 0.075; self.weaponframe=9;};
void()	player_rpistol3 =	[$AttackA3, player_rpistol4	] {self.nextthink = time + 0.075; self.weaponframe=10;
sound (self, CHAN_WEAPON, "weapons/p_clipout.wav", 1, ATTN_NORM);};
void()	player_rpistol4 =	[$AttackA4, player_rpistol5	] {self.nextthink = time + 0.075; self.weaponframe=11;};
void()	player_rpistol5 =	[$AttackA5, player_rpistol6	] {self.nextthink = time + 0.075; self.weaponframe=12;};
void()	player_rpistol6 =	[$AttackA6, player_rpistol7	] {self.nextthink = time + 0.075; self.weaponframe=13;
sound (self, CHAN_WEAPON, "weapons/p_clipin.wav", 1, ATTN_NORM);};
void()	player_rpistol7 =	[$AttackA6, player_rpistol8	] {self.nextthink = time + 0.075; self.weaponframe=14;};
void()	player_rpistol8 =	[$AttackA6, player_rpistol9	] {self.nextthink = time + 0.075; self.weaponframe=15;};
void()	player_rpistol9 =	[$AttackA6, player_rpistol10	] {self.nextthink = time + 0.075; self.weaponframe=16;};
void()	player_rpistol10 =	[$AttackA6, player_rpistol11	] {self.nextthink = time + 0.075; self.weaponframe=17;};
void()	player_rpistol11 =	[$AttackA6, player_rpistol12	] {self.nextthink = time + 0.075; self.weaponframe=18;};
void()	player_rpistol12 =	[$AttackA6, player_rpistol13	] {self.nextthink = time + 0.075; self.weaponframe=19;};
void()	player_rpistol13 =	[$AttackA6, player_rpistol14	] {self.nextthink = time + 0.075; self.weaponframe=20;
sound (self, CHAN_WEAPON, "weapons/p_slide_f.wav", 1, ATTN_NORM);};
void()	player_rpistol14 =	[$AttackA6, player_rpistol15	] {self.nextthink = time + 0.075; self.weaponframe=21;};
void()	player_rpistol15 =	[$AttackA6, player_run	]
{
	if (deathmatch & DM_INFINITE_AMMO)
		self.currentammo = (self.bulletclip = 8);

    else if((self.ammo_nails1 >= 1) && (self.ammo_nails1 <= 8) )
    {
        self.currentammo = self.bulletclip = self.ammo_nails1;
        self.ammo_nails1 = 0;

        if (self.ammo_nails1 < 0)
            self.ammo_nails1 = 0;
        if (self.ammo_nails1 > 250)
            self.ammo_nails1 = 0;
    }
    else
    {
		if (self.bulletclip == 7)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 1);
        }
		else if (self.bulletclip == 6)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 2);
        }
		else if (self.bulletclip == 5)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 3);
        }
		else if (self.bulletclip == 4)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 4);
        }
		else if (self.bulletclip == 3)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 5);
        }
		else if (self.bulletclip == 2)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 6);
        }
		else if (self.bulletclip == 1)
		{
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 7);
        }
        else
        {
		    self.currentammo = (self.bulletclip = 8);
		    self.ammo_nails1 = (self.ammo_nails1 - 8);
        }
    }

	UpdateAmmoCounts(self);
    self.weaponframe=21;
};

//============================================================================
// Shotgun
//============================================================================

void() player_shot1;
void() player_shot1 =
{
    self.nextthink = time + 0.1;
    self.think = player_shot1;

	self.weaponframe = self.weaponframe + 1;

    if (self.weaponframe == 1)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 2)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    	
    if (self.weaponframe >= 8)
    {
       player_run ();
       return;
    }

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
        
    }
 
};

//============================================================================
// Rifle
//============================================================================

void() player_rifle1;
void() player_rifle2;

void() player_rifle1   =
{
    self.nextthink = time + 0.1;
    self.think = player_rifle2;
    
    if (self.rifleclip == 0)
    {
        self.weaponframe = 0;
        return;
    }

	if (!self.button0)
	{
        self.effects = self.effects | EF_MUZZLEFLASH;
        player_run ();
        return;
    }

	self.effects = self.effects | EF_MUZZLEFLASH;
	self.weaponframe = self.weaponframe + 1;
	if (self.weaponframe >= 3)
		self.weaponframe = 1;
	SuperDamageSound();

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }

};

void() player_rifle2   =
{
    self.nextthink = time + 0.1;
    self.think = player_rifle1;
    
    if (self.rifleclip == 0)
    {
        self.weaponframe = 0;
        return;	
    }

	if (!self.button0)
	{
        self.effects = self.effects | EF_MUZZLEFLASH;
        player_run ();
        return;
    }

	self.effects = self.effects | EF_MUZZLEFLASH;
	self.weaponframe = self.weaponframe + 1;
	if (self.weaponframe >= 3)
		self.weaponframe = 1;
	SuperDamageSound();
	
// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }
};

void()	player_rrifle1 =	[$AttackA1, player_rrifle2	] {self.weaponframe=3;};
void()	player_rrifle2 =	[$AttackA2, player_rrifle3	] {self.weaponframe=4;};
void()	player_rrifle3 =	[$AttackA2, player_rrifle4	] {self.weaponframe=5;};
void()	player_rrifle4 =	[$AttackA3, player_rrifle5	] {self.weaponframe=6;
sound (self, CHAN_WEAPON, "weapons/p_clipout.wav", 1, ATTN_NORM);};
void()	player_rrifle5 =	[$AttackA4, player_rrifle6	] {self.weaponframe=7;};
void()	player_rrifle6 =	[$AttackA5, player_rrifle7	] {self.weaponframe=8;};
void()	player_rrifle7 =	[$AttackA6, player_rrifle8	] {self.weaponframe=9;};
void()	player_rrifle8 =	[$AttackA6, player_rrifle9	] {self.weaponframe=10;};
void()	player_rrifle9 =	[$AttackA6, player_rrifle10	] {self.weaponframe=11;
sound (self, CHAN_WEAPON, "weapons/p_clipin.wav", 1, ATTN_NORM);};
void()	player_rrifle10 =	[$AttackA6, player_rrifle11	] {self.weaponframe=12;};
void()	player_rrifle11 =	[$AttackA6, player_rrifle12	] {self.weaponframe=13;};
void()	player_rrifle12 =	[$AttackA6, player_rrifle13	] {self.weaponframe=14;
sound (self, CHAN_WEAPON, "weapons/p_slide_b.wav", 1, ATTN_NORM);};
void()	player_rrifle13 =	[$AttackA6, player_rrifle14	] {self.weaponframe=15;};
void()	player_rrifle14 =	[$AttackA6, player_rrifle15	] {self.weaponframe=16;};
void()	player_rrifle15 =	[$AttackA6, player_rrifle16	] {self.weaponframe=17;};
void()	player_rrifle16 =	[$AttackA6, player_rrifle17	] {self.weaponframe=18;};
void()	player_rrifle17 =	[$AttackA6, player_run	] 
{
	if (deathmatch & DM_INFINITE_AMMO)
		self.currentammo = (self.rifleclip = 24);

    else if((self.ammo_nails1 >= 1) && (self.ammo_nails1 <= 24) )
    {
        self.currentammo = self.rifleclip = self.ammo_nails1;
        self.ammo_nails1 = 0;

        if (self.ammo_nails1 < 0)
            self.ammo_nails1 = 0;
        if (self.ammo_nails1 > 250)
            self.ammo_nails1 = 0;
    }
    else
    {
		if (self.rifleclip == 23)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 1);
        }
		else if (self.rifleclip == 22)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 2);
        }
		else if (self.rifleclip == 21)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 3);
        }
		else if (self.rifleclip == 20)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 4);
        }
		else if (self.rifleclip == 19)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 5);
        }
		else if (self.rifleclip == 18)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 6);
        }
		else if (self.rifleclip == 17)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 7);
        }
		else if (self.rifleclip == 16)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 8);
        }
		else if (self.rifleclip == 15)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 9);
        }
		else if (self.rifleclip == 14)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 10);
        }
		else if (self.rifleclip == 13)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 11);
        }
		else if (self.rifleclip == 12)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 12);
        }
		else if (self.rifleclip == 11)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 13);
        }
		else if (self.rifleclip == 10)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 14);
        }
		else if (self.rifleclip == 9)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 15);
        }
		else if (self.rifleclip == 8)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 16);
        }
		else if (self.rifleclip == 7)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 17);
        }
		else if (self.rifleclip == 6)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 18);
        }
		else if (self.rifleclip == 5)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 19);
        }
		else if (self.rifleclip == 4)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 20);
        }
		else if (self.rifleclip == 3)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 21);
        }
		else if (self.rifleclip == 2)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 22);
        }
		else if (self.rifleclip == 1)
		{
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 23);
        }
        else
        {
		    self.currentammo = (self.rifleclip = 24);
		    self.ammo_nails1 = (self.ammo_nails1 - 24);
        }
    }
		UpdateAmmoCounts(self);
		self.weaponframe=19;
};


//============================================================================
// Uzi
//============================================================================

void()	player_uzi1;

void()	player_uzi1 =
{
	self.weaponframe = self.weaponframe + 1;
	self.nextthink = time + 0.025;
	self.think = player_uzi1;

    if (self.weaponframe == 1)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 2)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 3)
    	self.effects = self.effects | EF_MUZZLEFLASH;

	if (self.weaponframe >= 4)
	{
		player_run ();
		return;
    }

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;

		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }

}

void()	player_ruzi1 =	[$AttackA1, player_ruzi2	] {self.weaponframe=8;};
void()	player_ruzi2 =	[$AttackA2, player_ruzi3	] {self.weaponframe=9;};
void()	player_ruzi3 =	[$AttackA3, player_ruzi4	] {self.weaponframe=10;
sound (self, CHAN_WEAPON, "weapons/p_clipout.wav", 1, ATTN_NORM);};
void()	player_ruzi4 =	[$AttackA4, player_ruzi5	] {self.weaponframe=11;};
void()	player_ruzi5 =	[$AttackA5, player_ruzi6	] {self.weaponframe=12;};
void()	player_ruzi6 =	[$AttackA6, player_ruzi7	] {self.weaponframe=13;
sound (self, CHAN_WEAPON, "weapons/p_clipin.wav", 1, ATTN_NORM);};
void()	player_ruzi7 =	[$AttackA6, player_ruzi8	] {self.weaponframe=14;};
void()	player_ruzi8 =	[$AttackA6, player_ruzi9	] {self.weaponframe=15;};
void()	player_ruzi9 =	[$AttackA6, player_ruzi10	] {self.weaponframe=16;};
void()	player_ruzi10 =	[$AttackA6, player_ruzi11	] {self.weaponframe=17;};
void()	player_ruzi11 =	[$AttackA6, player_ruzi12	] {self.weaponframe=18;};
void()	player_ruzi12 =	[$AttackA6, player_ruzi13	] {self.weaponframe=19;
sound (self, CHAN_WEAPON, "weapons/p_slide_f.wav", 1, ATTN_NORM);};
void()	player_ruzi13 =	[$AttackA6, player_ruzi14	] {self.weaponframe=20;};
void()	player_ruzi14 =	[$AttackA6, player_ruzi15	] {self.weaponframe=21;};
void()	player_ruzi15 =	[$AttackA6, player_run	]
{
	if (deathmatch & DM_INFINITE_AMMO)
		self.currentammo = (self.uziclip = 32);

    else if((self.ammo_nails1 >= 1) && (self.ammo_nails1 <= 32) )
    {
        self.currentammo = self.uziclip = self.ammo_nails1;
        self.ammo_nails1 = 0;

        if (self.ammo_nails1 < 0)
            self.ammo_nails1 = 0;
        if (self.ammo_nails1 > 250)
            self.ammo_nails1 = 0;
    }
    else
    {
		if (self.uziclip == 31)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 1);
        }
		else if (self.uziclip == 30)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 2);
        }
		else if (self.uziclip == 29)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 3);
        }
		else if (self.uziclip == 28)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 4);
        }
		else if (self.uziclip == 27)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 5);
        }
		else if (self.uziclip == 26)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 6);
        }
		else if (self.uziclip == 25)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 7);
        }
		else if (self.uziclip == 24)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 8);
        }
		else if (self.uziclip == 23)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 9);
        }
		else if (self.uziclip == 22)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 10);
        }
		else if (self.uziclip == 21)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 11);
        }
		else if (self.uziclip == 20)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 12);
        }
		else if (self.uziclip == 19)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 13);
        }
		else if (self.uziclip == 18)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 14);
        }
		else if (self.uziclip == 17)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 15);
        }
		else if (self.uziclip == 16)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 16);
        }
		else if (self.uziclip == 15)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 17);
        }
		else if (self.uziclip == 14)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 18);
        }
		else if (self.uziclip == 13)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 19);
        }
		else if (self.uziclip == 12)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 20);
        }
		else if (self.uziclip == 11)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 21);
        }
		else if (self.uziclip == 10)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 22);
        }
		else if (self.uziclip == 9)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 23);
        }
		else if (self.uziclip == 8)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 24);
        }
		else if (self.uziclip == 7)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 25);
        }
		else if (self.uziclip == 6)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 26);
        }
		else if (self.uziclip == 5)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 27);
        }
		else if (self.uziclip == 4)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 28);
        }
		else if (self.uziclip == 3)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 29);
        }
		else if (self.uziclip == 2)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 30);
        }
		else if (self.uziclip == 1)
		{
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 31);
        }
        else
        {
		    self.currentammo = (self.uziclip = 32);
		    self.ammo_nails1 = (self.ammo_nails1 - 32);
        }
    }

	UpdateAmmoCounts(self);
    self.weaponframe=21;
};

//============================================================================
// Sniper Rifle
//============================================================================

void() player_srifle;

void()	player_srifle =
{
    self.aflag = 1;
    self.ammoready = 0;

	self.weaponframe = self.weaponframe + 1;
	self.nextthink = time + 0.1;
	self.think = player_srifle;

    if (self.weaponframe == 1)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 2)
    	self.effects = self.effects | EF_MUZZLEFLASH;
    if (self.weaponframe == 3)
    	self.effects = self.effects | EF_MUZZLEFLASH;
	if (self.weaponframe == 8)
		sound (self, CHAN_WEAPON, "weapons/p_slide_f.wav", 1, ATTN_NORM);
//	if (self.weaponframe == )
//		sound (self, CHAN_WEAPON, "weapons/p_clipout.wav", 1, ATTN_NORM);
	if (self.weaponframe == 14)
		sound (self, CHAN_WEAPON, "weapons/p_clipin.wav", 1, ATTN_NORM);
	if (self.weaponframe == 17)
		sound (self, CHAN_WEAPON, "weapons/p_slide_f.wav", 1, ATTN_NORM);

	if (self.weaponframe >= 23)
	{
        self.aflag=0;
        self.ammoready=1;
//		self.attack_finished = time;
		if (self.zoomtoggle == 1)
			W_SetAmmoOnly();
		else
            W_SetCurrentAmmo();
		player_run ();
		return;
    }

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;

		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }

}

//============================================================================
// Minigun
//============================================================================

void() player_minigun1;
void() player_minigun2;

void() player_minigun1   =
{
    self.nextthink = time + 0.08;
	self.effects = self.effects | EF_MUZZLEFLASH;

	if (!self.button0)
	{
        player_run ();
		self.weaponframe = 0;
        return;
    }

	self.weaponframe = self.weaponframe + 1;
	if (self.weaponframe >= 6)
		self.weaponframe = 1;
	SuperDamageSound();
	
// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }
	
};

void() player_minigun2   =
{
    self.nextthink = time + 0.08;
	self.effects = self.effects | EF_MUZZLEFLASH;

	if (!self.button0)
	{
        player_run ();
        return;
    }

	self.weaponframe = self.weaponframe + 1;
	if (self.weaponframe >= 6)
		self.weaponframe = 1;
	SuperDamageSound();
	
// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }
	
};

//============================================================================

void() player_light1;
void() player_light2;

void() player_light1   =
{
	self.effects = self.effects | EF_MUZZLEFLASH;
/*
	if (!self.button0)
	{
        player_run ();
        return;
    }
*/
	self.weaponframe = self.weaponframe + 1;
	if (self.weaponframe >= 5)
		self.weaponframe = 1;
	SuperDamageSound();
	W_FireLightning();
	self.attack_finished = time + 0.2;

// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }

};

void() player_light2   =
{
	self.effects = self.effects | EF_MUZZLEFLASH;
/*
	if (!self.button0)
	{
        player_run ();
        return;
    }
*/
	self.weaponframe = self.weaponframe + 1;
	if (self.weaponframe >= 5)
		self.weaponframe = 1;
	SuperDamageSound();
	W_FireLightning();
	self.attack_finished = time + 0.2;
	
// Player Model Animation

    p_speed = vlen (self.velocity);

	if (self.waterlevel > 1)
    {
	    if (self.walkframe >= 7)
            self.walkframe = 0;
	    self.frame = $Swim1 + self.walkframe;
	    self.walkframe = self.walkframe + 1;
    }

	else if (!(self.flags & FL_ONGROUND))
	{
        if (self.walkframe >= 3)
		    self.walkframe = 2;
    	self.frame = $Jump1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

    else if (p_speed >= 125)
	{
		if (self.walkframe >= 8)
			self.walkframe = 0;

		self.frame = $Run1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
        
		if (self.walkframe == 1 || self.walkframe == 5 )
        {
            if (checkbottom(self) == TRUE)
            {
                if (self.waterlevel == 0)
				{
				    local float r;
					r = rint(random() * 3);			
					if (r == 1)
				         sound (self, CHAN_AUTO, "player/footsteps/step1.wav", 1, ATTN_NORM);
					else if (r == 2)
				         sound (self, CHAN_AUTO, "player/footsteps/step2.wav", 1, ATTN_NORM);
					else if (r == 0)
				         sound (self, CHAN_AUTO, "player/footsteps/step3.wav", 1, ATTN_NORM);
					else
			             sound (self, CHAN_AUTO, "player/footsteps/step4.wav", 1, ATTN_NORM);
				}
            }
        }      
	}

	else if (p_speed >= 1)
	{
        if (self.walkframe >= 6)
            self.walkframe = 0;
        self.frame = $Walk1 + self.walkframe;
        self.walkframe = self.walkframe + 1;
	}

	else
	{
        self.walkframe=0;
        self.frame = $Ready1;
    }
	
};

//============================================================================

/*
void() player_rocket1;
void() player_rocket2;
void() player_rocket3;
void() player_rocket4;
void() player_rocket5;
void() player_rocket6;

void() player_rocket1  = {self.think = player_rocket2; {self.weaponframe=1; self.effects = self.effects | EF_MUZZLEFLASH;};
void() player_rocket2  = {self.think = player_rocket3; {self.weaponframe=2;};
void() player_rocket3  = {self.think = player_rocket4; {self.weaponframe=3;};
void() player_rocket4  = {self.think = player_rocket5; {self.weaponframe=4;};
void() player_rocket5  = {self.think = player_rocket6; {self.weaponframe=5;};
void() player_rocket6  = {self.think = player_run; {self.weaponframe=6;};
*/

void() player_rocket1   =[$AttackA1, player_rocket2  ] {self.weaponframe=1;
self.effects = self.effects | EF_MUZZLEFLASH;};
void() player_rocket2   =[$AttackA2, player_rocket3  ] {self.weaponframe=2;};
void() player_rocket3   =[$AttackA3, player_rocket4  ] {self.weaponframe=3;};
void() player_rocket4   =[$AttackA4, player_rocket5  ] {self.weaponframe=4;};
void() player_rocket5   =[$AttackA5, player_rocket6  ] {self.weaponframe=5;};
void() player_rocket6   =[$AttackA6, player_run  ] {self.weaponframe=6;};
void(float num_bubbles) DeathBubbles;

void() PainSound =
{
local float		rs;

	if (self.health < 0)
		return;

	if (damage_attacker.classname == "teledeath")
	{
		sound (self, CHAN_VOICE, "player/teledth1.wav", 1, ATTN_NONE);
		return;
	}

// water pain sounds
	if (self.watertype == CONTENT_WATER && self.waterlevel == 3)
	{
		DeathBubbles(1);
		if (random() > 0.5)
			sound (self, CHAN_VOICE, "player/drown1.wav", 1, ATTN_NORM);
		else
			sound (self, CHAN_VOICE, "player/drown2.wav", 1, ATTN_NORM);
		return;
	}

// slime pain sounds
	if (self.watertype == CONTENT_SLIME)
	{
// FIX ME	put in some steam here
		if (self.waterlevel == 3)
			DeathBubbles(1);
		if (random() > 0.5)
			sound (self, CHAN_VOICE, "player/lburn1.wav", 1, ATTN_NORM);
		else
			sound (self, CHAN_VOICE, "player/lburn2.wav", 1, ATTN_NORM);
		return;
	}

	if (self.watertype == CONTENT_LAVA)
	{
		if (random() > 0.5)
			sound (self, CHAN_VOICE, "player/lburn1.wav", 1, ATTN_NORM);
		else
			sound (self, CHAN_VOICE, "player/lburn2.wav", 1, ATTN_NORM);
		return;
	}

	if (self.pain_finished > time)
	{
		self.axhitme = 0;
		return;
	}
	self.pain_finished = time + 0.5;

// don't make multiple pain sounds right after each other

// ax pain sound
	if (self.axhitme == 1)
	{
		self.axhitme = 0;
		sound (self, CHAN_VOICE, "player/axhit1.wav", 1, ATTN_NORM);
		return;
	}

	rs = rint((random() * 10) + 1);

	if (rs == 1)
		self.noise = "player/pain1.wav";
	if (rs == 2)
		self.noise = "player/pain2.wav";
	if (rs == 3)
		self.noise = "player/pain3.wav";
	if (rs == 4)
		self.noise = "player/pain4.wav";
	if (rs == 5)
		self.noise = "player/pain5.wav";
	if (rs == 6)
		self.noise = "player/pain6.wav";
	if (rs == 7)
		self.noise = "player/pain7.wav";
	if (rs == 8)
		self.noise = "player/pain8.wav";
	if (rs == 9)
		self.noise = "player/pain9.wav";
	if (rs == 10)
		self.noise = "player/pain10.wav";
	if (rs == 11)
		self.noise = "player/pain11.wav";

	sound (self, 5, self.noise, 1, ATTN_NORM);
	return;
};
/*
void()	player_pain1 =	[	$Pain1,	player_pain2	] {PainSound();self.weaponframe=0;};
void()	player_pain2 =	[	$Pain2,	player_pain3	] {};
void()	player_pain3 =	[	$Pain3,	player_pain4	] {};
void()	player_pain4 =	[	$Pain4,	player_pain5	] {};
void()	player_pain5 =	[	$Pain5,	player_pain6	] {};
void()	player_pain6 =	[	$Pain6,	player_run	] {};

void()	player_axpain1 =	[	$Pain1,	player_axpain2	] {PainSound();self.weaponframe=0;};
void()	player_axpain2 =	[	$Pain2,	player_axpain3	] {};
void()	player_axpain3 =	[	$Pain3,	player_axpain4	] {};
void()	player_axpain4 =	[	$Pain4,	player_axpain5	] {};
void()	player_axpain5 =	[	$Pain5,	player_axpain6	] {};
void()	player_axpain6 =	[	$Pain6,	player_run	] {};
*/
void() player_pain =
{
	if (self.weaponframe)
		return;

	if (self.invisible_finished > time)
		return;		// eyes don't have pain frames

    PainSound();

//	if (self.weapon == IT_AXE)
//		player_axpain1 ();
//	else
//		player_pain1 ();
};

void() player_diea1;
void() player_dieb1;
//void() player_diec1;
//void() player_died1;
//void() player_diee1;
//void() player_die_ax1;

void() DeathBubblesSpawn =
{
local entity	bubble;
//	if (self.owner.waterlevel != 3)
	if ((self.owner.waterlevel != 3) && (self.owner.health > 0))
		{
			remove(self);	// remove bubble spawner
			return;
		}
	bubble = spawn();
	setmodel (bubble, "progs/s_bubble.spr");
	setorigin (bubble, self.owner.origin + '0 0 24');
	bubble.movetype = MOVETYPE_NOCLIP;
	bubble.solid = SOLID_NOT;
	bubble.velocity = '0 0 15';
	bubble.nextthink = time + 0.5;
	bubble.think = bubble_bob;
	bubble.classname = "bubble";
	bubble.frame = 0;
	bubble.cnt = 0;
	setsize (bubble, '-8 -8 -8', '8 8 8');
//	self.nextthink = time + 0.1;
	self.nextthink = time + 0.01;
	self.think = DeathBubblesSpawn;
	self.air_finished = self.air_finished + 1;
	if (self.air_finished >= self.bubble_count)
		remove(self);
};

void(float num_bubbles) DeathBubbles =
{
local entity	bubble_spawner;
	
	bubble_spawner = spawn();
	setorigin (bubble_spawner, self.origin);
	bubble_spawner.movetype = MOVETYPE_NONE;
	bubble_spawner.solid = SOLID_NOT;
//	bubble_spawner.nextthink = time + 0.1;
	bubble_spawner.nextthink = time + 0.01;
	bubble_spawner.think = DeathBubblesSpawn;
	bubble_spawner.air_finished = 0;
	bubble_spawner.owner = self;
	bubble_spawner.bubble_count = num_bubbles;
//	return;
};


void() DeathSound =
{
	local float		rs;

	// water death sounds
	if (self.waterlevel == 3)
	{
		DeathBubbles(20);
		sound (self, CHAN_VOICE, "player/h2odeath.wav", 1, ATTN_NORM);
		return;
	}

    rs = rint ((random() * 3) + 1);
    if (rs == 1)
		self.noise = "player/death1.wav";
	if (rs == 2)
		self.noise = "player/death2.wav";
	if (rs == 3)
		self.noise = "player/death3.wav";
	if (rs == 4)
		self.noise = "player/death4.wav";

	sound (self, CHAN_VOICE, self.noise, 1, ATTN_NORM);
	return;
};

void() GibImpactSounds =
{
	local float		rs;

    rs = rint ((random() * 3) + 1);
    if (rs == 1)
		self.noise = "player/gibimp1.wav";
	if (rs == 2)
		self.noise = "player/gibimp2.wav";
	if (rs == 3)
		self.noise = "player/gibimp3.wav";
	if (rs == 4)
		self.noise = "player/gibimp4.wav";

	sound (self, CHAN_AUTO, self.noise, 1, ATTN_NORM);
}

void() PlayerDead =
{
	self.nextthink = -5;
// allow respawn after a certain time
	self.deadflag = DEAD_DEAD;
	self.model =  "";
	self.frame = $Death12;
};

vector(float dm) VelocityForDamage =
{
	local vector v;

	v_x = 150 * crandom();
	v_y = 150 * crandom();
	v_z = 150 * random();

	return v;
};

void(string gibname, float dm) ThrowGib =
{
	local	entity new;

	new = spawn();
	setmodel (new, gibname);
	setsize (new, '0 0 0', '0 0 0');
	new.velocity = VelocityForDamage (dm);
	new.movetype = MOVETYPE_BOUNCE;
	new.solid = SOLID_NOT;
	new.touch = GibImpactSounds;

	new.origin_x = self.origin_x + (crandom()*8);
	new.origin_y = self.origin_y + (crandom()*8);
	new.origin_z = self.origin_z + (random()*16);

	new.avelocity_x = random()*600;
	new.avelocity_y = random()*600;
	new.avelocity_z = random()*600;

	new.think = SUB_Remove;
	new.ltime = time;
	new.nextthink = time + 15 + random()*10;
	new.frame = 0;
	new.flags = 0;

	//----- Bind to Physics System ------------------------
//	P_ActivatePhysics(new, 500);
//	P_ActivateBouyancy(new, 700);
//	P_ActivateAerodynamics(new, 12);
};

void(string gibname, float dm) ThrowHead =
{
	setmodel (self, gibname);
	self.frame = 0;
	self.nextthink = -1;
	self.movetype = MOVETYPE_BOUNCE;
	self.takedamage = DAMAGE_NO;
	self.solid = SOLID_NOT;
	self.view_ofs = '0 0 8';
	setsize (self, '-16 -16 0', '16 16 56');
	self.velocity = VelocityForDamage (dm);
	self.origin_z = self.origin_z + 24;
	self.flags = self.flags - (self.flags & FL_ONGROUND);
	self.avelocity = crandom() * '0 600 0';

	//----- Bind to Physics System ------------------------
//	P_ActivatePhysics(self, 500);
//	P_ActivateBouyancy(self, 700);
};


void() GibPlayer =
{
//	ThrowHead ("progs/h_player.mdl", self.health);
	ThrowHead ("progs/gib1.mdl", self.health);
	ThrowGib ("progs/gib1.mdl", self.health);
	ThrowGib ("progs/gib2.mdl", self.health);
	ThrowGib ("progs/gib2.mdl", self.health);
	ThrowGib ("progs/gib3.mdl", self.health);
	ThrowGib ("progs/gib3.mdl", self.health);

	self.deadflag = DEAD_DEAD;

	if (damage_attacker.classname == "teledeath")
	{
		sound (self, CHAN_VOICE, "player/teledth1.wav", 1, ATTN_NONE);
		return;
	}

	if (damage_attacker.classname == "teledeath2")
	{
		sound (self, CHAN_VOICE, "player/teledth1.wav", 1, ATTN_NONE);
		return;
	}
		
	if (random() < 0.5)
		sound (self, CHAN_VOICE, "player/gib.wav", 1, ATTN_NONE);
	else
		sound (self, CHAN_VOICE, "player/gibsplt1.wav", 1, ATTN_NONE);
};

void() PlayerDie =
{
	local	float	i;
	
	spawn_protect_off ();
//	self.items = self.items - (self.items & IT_INVISIBILITY);
	self.items = self.items - (self.items &
	(IT_INVISIBILITY | IT_INVULNERABILITY | IT_SUIT | IT_QUAD) );
	self.invisible_finished = 0;	// don't die as eyes
	self.invincible_finished = 0;
	self.super_damage_finished = 0;
	self.radsuit_finished = 0;
	self.effects = 0;	// 1998-07-23 Glowing corpse of players which had quad/pentagram until respawn fix by Maddes

	if (deathmatch & DM_DM_MASK || coop)
		WeaponDrop();
	
	self.weaponmodel="";
	self.view_ofs = '0 0 -8';
	self.deadflag = DEAD_DYING;
	self.solid = SOLID_NOT;
	self.flags = self.flags - (self.flags & FL_ONGROUND);
	self.movetype = MOVETYPE_TOSS;
	if (self.velocity_z < 10)
		self.velocity_z = self.velocity_z + random()*300;

	if (self.health < -50)
	{
		if (damage_attacker.weapon == IT_ROCKET_LAUNCHER ||
			damage_attacker.weapon == IT_GRENADE_LAUNCHER ||
			damage_attacker.weapon == IT_LIGHTNING)
		{
			GibPlayer ();
			return;
		}
	}

	DeathSound();
	
	self.angles_x = 0;
	self.angles_z = 0;
	
	if (self.weapon == IT_AXE)
        self.modelindex = modelindex_knife;
	else
		self.modelindex = modelindex_player;

//	i = cvar("temp1");
//	if (!i)
//		i = 1 + floor(random()*6);
	
//	if (i == 1)
		player_diea1();
//	else if (i == 2)
//		player_diea1();
//	else if (i == 3)
//		player_diea1();
//	else if (i == 4)
//		player_diea1();
//	else
//		player_diea1();

};

void() set_suicide_frame =
{
    // used by kill command and diconnect command
/*
	if (self.model != "progs/player.mdl" ||
        self.model != "progs/p_knife.mdl" ||
        self.model != "progs/p_tekbow.mdl" ||
        self.model != "progs/p_pistol.mdl")
		return;	// allready gibbed
*/
	self.frame = 62;
	self.solid = SOLID_NOT;
	self.movetype = MOVETYPE_TOSS;
	self.deadflag = DEAD_DEAD;
	self.nextthink = -1;
};

void()	player_diea1	=	[	$Death1,	player_diea2	] {};
void()	player_diea2	=	[	$Death2,	player_diea3	] {};
void()	player_diea3	=	[	$Death3,	player_diea4	] {};
void()	player_diea4	=	[	$Death4,	player_diea5	] {};
void()	player_diea5	=	[	$Death5,	player_diea6	] {};
void()	player_diea6	=	[	$Death6,	player_diea7	] {};
void()	player_diea7	=	[	$Death7,	player_diea8	] {};
void()	player_diea8	=	[	$Death8,	player_diea9	] {};
void()	player_diea9	=	[	$Death9,	player_diea10	] {};
void()	player_diea10	=	[	$Death10,	player_diea11	] {};
void()	player_diea11	=	[	$Death11,	player_diea12	] {};
void()	player_diea12	=	[	$Death12,	player_diea12 ] {PlayerDead();};

void()	player_dieb1	=	[	$Death1,	player_dieb2	] {self.nextthink = time + 0.05;};
void()	player_dieb2	=	[	$Death2,	player_dieb3	] {self.nextthink = time + 0.05;};
void()	player_dieb3	=	[	$Death3,	player_dieb4	] {self.nextthink = time + 0.05;};
void()	player_dieb4	=	[	$Death4,	player_dieb5	] {self.nextthink = time + 0.05;};
void()	player_dieb5	=	[	$Death5,	player_dieb6	] {self.nextthink = time + 0.05;};
void()	player_dieb6	=	[	$Death6,	player_dieb7	] {self.nextthink = time + 0.05;};
void()	player_dieb7	=	[	$Death7,	player_dieb8	] {self.nextthink = time + 0.05;};
void()	player_dieb8	=	[	$Death8,	player_dieb9	] {self.nextthink = time + 0.05;};
void()	player_dieb9	=	[	$Death9,	player_dieb10	] {self.nextthink = time + 0.05;};
void()	player_dieb10	=	[	$Death10,	player_dieb11	] {self.nextthink = time + 0.05;};
void()	player_dieb11	=	[	$Death11,	player_dieb12	] {self.nextthink = time + 0.05;};
void()	player_dieb12	=	[	$Death12,	player_dieb12 ] {PlayerDead();};
/*
void()	player_dieb1	=	[	$deathb1,	player_dieb2	] {};
void()	player_dieb2	=	[	$deathb2,	player_dieb3	] {};
void()	player_dieb3	=	[	$deathb3,	player_dieb4	] {};
void()	player_dieb4	=	[	$deathb4,	player_dieb5	] {};
void()	player_dieb5	=	[	$deathb5,	player_dieb6	] {};
void()	player_dieb6	=	[	$deathb6,	player_dieb7	] {};
void()	player_dieb7	=	[	$deathb7,	player_dieb8	] {};
void()	player_dieb8	=	[	$deathb8,	player_dieb9	] {};
void()	player_dieb9	=	[	$deathb9,	player_dieb9	] {PlayerDead();};

void()	player_diec1	=	[	$deathc1,	player_diec2	] {};
void()	player_diec2	=	[	$deathc2,	player_diec3	] {};
void()	player_diec3	=	[	$deathc3,	player_diec4	] {};
void()	player_diec4	=	[	$deathc4,	player_diec5	] {};
void()	player_diec5	=	[	$deathc5,	player_diec6	] {};
void()	player_diec6	=	[	$deathc6,	player_diec7	] {};
void()	player_diec7	=	[	$deathc7,	player_diec8	] {};
void()	player_diec8	=	[	$deathc8,	player_diec9	] {};
void()	player_diec9	=	[	$deathc9,	player_diec10	] {};
void()	player_diec10	=	[	$deathc10,	player_diec11	] {};
void()	player_diec11	=	[	$deathc11,	player_diec12	] {};
void()	player_diec12	=	[	$deathc12,	player_diec13	] {};
void()	player_diec13	=	[	$deathc13,	player_diec14	] {};
void()	player_diec14	=	[	$deathc14,	player_diec15	] {};
void()	player_diec15	=	[	$deathc15,	player_diec15 ] {PlayerDead();};

void()	player_died1	=	[	$deathd1,	player_died2	] {};
void()	player_died2	=	[	$deathd2,	player_died3	] {};
void()	player_died3	=	[	$deathd3,	player_died4	] {};
void()	player_died4	=	[	$deathd4,	player_died5	] {};
void()	player_died5	=	[	$deathd5,	player_died6	] {};
void()	player_died6	=	[	$deathd6,	player_died7	] {};
void()	player_died7	=	[	$deathd7,	player_died8	] {};
void()	player_died8	=	[	$deathd8,	player_died9	] {};
void()	player_died9	=	[	$deathd9,	player_died9	] {PlayerDead();};

void()	player_diee1	=	[	$deathe1,	player_diee2	] {};
void()	player_diee2	=	[	$deathe2,	player_diee3	] {};
void()	player_diee3	=	[	$deathe3,	player_diee4	] {};
void()	player_diee4	=	[	$deathe4,	player_diee5	] {};
void()	player_diee5	=	[	$deathe5,	player_diee6	] {};
void()	player_diee6	=	[	$deathe6,	player_diee7	] {};
void()	player_diee7	=	[	$deathe7,	player_diee8	] {};
void()	player_diee8	=	[	$deathe8,	player_diee9	] {};
void()	player_diee9	=	[	$deathe9,	player_diee9	] {PlayerDead();};

void()	player_die_ax1	=	[	$axdeth1,	player_die_ax2	] {};
void()	player_die_ax2	=	[	$axdeth2,	player_die_ax3	] {};
void()	player_die_ax3	=	[	$axdeth3,	player_die_ax4	] {};
void()	player_die_ax4	=	[	$axdeth4,	player_die_ax5	] {};
void()	player_die_ax5	=	[	$axdeth5,	player_die_ax6	] {};
void()	player_die_ax6	=	[	$axdeth6,	player_die_ax7	] {};
void()	player_die_ax7	=	[	$axdeth7,	player_die_ax8	] {};
void()	player_die_ax8	=	[	$axdeth8,	player_die_ax9	] {};
void()	player_die_ax9	=	[	$axdeth9,	player_die_ax9	] {PlayerDead();};
*/
