/*
==============================================================================

Raptor

==============================================================================
*/

$cd id1/models/raptor
$scale	0.8
$origin 0 0 24
$base base
$skin base

$frame Idle1 Idle2 Idle3 Idle4 Idle5 Idle6 Idle7 Idle8 Idle9
$frame Idle10

$frame walk1 walk2 walk3 walk4 walk5 walk6 walk7 walk8 walk9
$frame walk10

$frame run1 run2 run3 run4 run5 run6 run7 run8 run9
$frame run10

$frame attack1 attack2 attack3 attack4 attack5 attack6 attack7 attack8 attack9 attack10
$frame attack11 attack12 attack13 attack14

$frame Jump1 Jump2 Jump3 Jump4 Jump5 Jump6 Jump7 Jump8
$frame Jump9 Jump10 Jump11

$frame pain1 pain2 pain3 pain4 pain5

$frame death1 death2 death3 death4 death5 death6 death7 death8 death9

//============================================================================

void()	Demon_JumpTouch;

void()	demon1_stand1	=[	$Idle1,	demon1_stand2	] {ai_stand();};
void()	demon1_stand2	=[	$Idle2,	demon1_stand3	] {ai_stand();};
void()	demon1_stand3	=[	$Idle3,	demon1_stand4	] {ai_stand();};
void()	demon1_stand4	=[	$Idle4,	demon1_stand5	] {ai_stand();};
void()	demon1_stand5	=[	$Idle5,	demon1_stand6	] {ai_stand();};
void()	demon1_stand6	=[	$Idle6,	demon1_stand7	] {ai_stand();};
void()	demon1_stand7	=[	$Idle7,	demon1_stand8	] {ai_stand();};
void()	demon1_stand8	=[	$Idle8,	demon1_stand9	] {ai_stand();};
void()	demon1_stand9	=[	$Idle9,	demon1_stand10	] {ai_stand();};
void()	demon1_stand10	=[	$Idle10,demon1_stand1	] {ai_stand();};


void()	demon1_walk1	=[	$walk1,		demon1_walk2	] {
if (random() < 0.2)
    sound (self, CHAN_VOICE, "demon/idle1.wav", 1, ATTN_IDLE);
ai_walk(8);
};
void()	demon1_walk2	=[	$walk2,		demon1_walk3	] {ai_walk(6);};
void()	demon1_walk3	=[	$walk3,		demon1_walk4	] {ai_walk(6);};
void()	demon1_walk4	=[	$walk4,		demon1_walk5	] {ai_walk(7);};
void()	demon1_walk5	=[	$walk5,		demon1_walk6	] {ai_walk(4);};
void()	demon1_walk6	=[	$walk6,		demon1_walk7	] {ai_walk(6);};
void()	demon1_walk7	=[	$walk7,		demon1_walk8	] {ai_walk(10);};
void()	demon1_walk8	=[	$walk8,		demon1_walk9	] {ai_walk(10);};
void()	demon1_walk9	=[	$walk9,		demon1_walk10	] {ai_walk(10);};
void()	demon1_walk10	=[	$walk10,	demon1_walk1	] {ai_walk(10);};

void()	demon1_run1	=[	$run1,		demon1_run2	] {
if (random() < 0.2)
    sound (self, CHAN_VOICE, "demon/idle1.wav", 1, ATTN_IDLE);
ai_run(20);};
void()	demon1_run2	=[	$run2,		demon1_run3	] {ai_run(15);};
void()	demon1_run3	=[	$run3,		demon1_run4	] {ai_run(36);};
void()	demon1_run4	=[	$run4,		demon1_run5	] {ai_run(20);};
void()	demon1_run5	=[	$run5,		demon1_run6	] {ai_run(15);};
void()	demon1_run6	=[	$run6,		demon1_run7	] {ai_run(15);};
void()	demon1_run7	=[	$run7,		demon1_run8	] {ai_run(15);};
void()	demon1_run8	=[	$run8,		demon1_run9	] {ai_run(36);};
void()	demon1_run9	=[	$run9,		demon1_run10] {ai_run(15);};
void()	demon1_run10=[	$run10,		demon1_run1	] {ai_run(36);};

void()	demon1_jump1	=[	$Jump1,		demon1_jump2	] {ai_face();setsize (self, '-16 -16 -24', '16 16 32');};
void()	demon1_jump2	=[	$Jump2,		demon1_jump3	] {ai_face();};
void()	demon1_jump3	=[	$Jump3,		demon1_jump4	] {ai_face();};
void()	demon1_jump4	=[	$Jump4,		demon1_jump5	]
{
	ai_face();
	
	self.touch = Demon_JumpTouch;
	makevectors (self.angles);
	self.origin_z = self.origin_z + 1;
	self.velocity = v_forward * 320 + '0 0 300';
	if (self.flags & FL_ONGROUND)
	{
		self.flags = self.flags - FL_ONGROUND;
		setsize (self, '-16 -16 -24', '16 16 24');
	}
};
void()	demon1_jump5	=[	$Jump5,		demon1_jump6	] {};
void()	demon1_jump6	=[	$Jump6,		demon1_jump7	] {};
void()	demon1_jump7	=[	$Jump7,		demon1_jump8	] {};
void()	demon1_jump8	=[ 	$Jump8,		demon1_jump9	] {};
void()	demon1_jump9	=[ 	$Jump9,		demon1_jump10	] {};
void()	demon1_jump10	=[ 	$Jump10,	demon1_jump11	] {};
void()	demon1_jump11	=[ 	$Jump11,	demon1_jump1	] {
self.nextthink = time + 3;
// if three seconds pass, assume demon is stuck and jump again
};

void()	demon1_jump12	=[ 	$Jump1,	demon1_jump13	] {};
void()	demon1_jump13	=[ 	$Jump2,	demon1_jump14	] {};
void()	demon1_jump14	=[ 	$Jump3,	demon1_run1	] {setsize (self, '-16 -16 -24', '16 16 24');};


void()	demon1_atta1	=[	$attack1,		demon1_atta2	] {ai_face ();self.nextthink = time + 0.08;setsize (self, '-16 -16 -24', '16 16 32');};
void()	demon1_atta2	=[	$attack2,		demon1_atta3	] {self.nextthink = time + 0.08;};
void()	demon1_atta3	=[	$attack3,		demon1_atta4	] {self.nextthink = time + 0.08;};
void()	demon1_atta4	=[	$attack4,		demon1_atta5	] {ai_face ();self.nextthink = time + 0.08;};
void()	demon1_atta5	=[	$attack5,		demon1_atta6	] {self.nextthink = time + 0.08;};
void()	demon1_atta6	=[	$attack6,		demon1_atta7	] {self.nextthink = time + 0.08;};
void()	demon1_atta7	=[	$attack7,		demon1_atta8	] {Demon_Melee(200);self.nextthink = time + 0.08;};
void()	demon1_atta8	=[	$attack8,		demon1_atta9	] {self.nextthink = time + 0.08;};
void()	demon1_atta9	=[	$attack9,		demon1_atta10] {self.nextthink = time + 0.08;};
void()	demon1_atta10	=[	$attack10,		demon1_atta11] {self.nextthink = time + 0.08;};
void()	demon1_atta11	=[	$attack11,		demon1_atta12] {ai_face ();self.nextthink = time + 0.08;};
void()	demon1_atta12	=[	$attack12,		demon1_atta13] {self.nextthink = time + 0.08;};
void()	demon1_atta13	=[	$attack13,		demon1_atta14] {Demon_Melee(-200);self.nextthink = time + 0.08;setsize (self, '-16 -16 -24', '16 16 24');};
void()	demon1_atta14	=[	$attack14,		demon1_run1] {};

void()	demon1_pain1	=[	$pain1,		demon1_pain2	] {};
void()	demon1_pain2	=[	$pain2,		demon1_pain3	] {};
void()	demon1_pain3	=[	$pain3,		demon1_pain4	] {};
void()	demon1_pain4	=[	$pain4,		demon1_pain5	] {};
void()	demon1_pain5	=[	$pain5,		demon1_run1	] {};

void(entity attacker, float damage)	demon1_pain =
{
	if (self.touch == Demon_JumpTouch)
		return;

	if (self.pain_finished > time)
		return;

	self.pain_finished = time + 1;
    sound (self, CHAN_VOICE, "demon/dpain1.wav", 1, ATTN_NORM);

	if (random()*200 > damage)
		return;		// didn't flinch
		
	demon1_pain1 ();
};

void()	demon1_die1		=[	$death1,		demon1_die2	] {
sound (self, CHAN_VOICE, "demon/ddeath.wav", 1, ATTN_NORM);};
void()	demon1_die2		=[	$death2,		demon1_die3	] {self.solid = SOLID_NOT;};
void()	demon1_die3		=[	$death3,		demon1_die4	] {};
void()	demon1_die4		=[	$death4,		demon1_die5	] {};
void()	demon1_die5		=[	$death5,		demon1_die6	] {};
void()	demon1_die6		=[	$death6,		demon1_die7	] {};
void()	demon1_die7		=[	$death7,		demon1_die8	] {};
void()	demon1_die8		=[	$death8,		demon1_die9	] {};
void()	demon1_die9		=[	$death9,		demon1_die9 ] {};

void() demon_die =
{
// check for gib
	if (self.health < -50)
	{
		if (damage_attacker.weapon == IT_ROCKET_LAUNCHER ||
			damage_attacker.weapon == IT_GRENADE_LAUNCHER ||
			damage_attacker.weapon == IT_LIGHTNING)
		{
			sound (self, CHAN_VOICE, "player/udeath.wav", 1, ATTN_NORM);
//			ThrowHead ("progs/h_demon.mdl", self.health);
			ThrowHead ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			return;
		}
	}

// regular death
	demon1_die1 ();
};


void() Demon_MeleeAttack =
{
	demon1_atta1 ();
};


/*QUAKED monster_demon1 (1 0 0) (-32 -32 -24) (32 32 64) Ambush

*/
void() monster_demon1 =
{
	if (deathmatch & DM_DM_MASK)
	{
		remove(self);
		return;
	}
	precache_model ("progs/raptor.mdl");
//	precache_model ("progs/h_demon.mdl");

	precache_sound ("demon/ddeath.wav");
	precache_sound ("demon/dhit2.wav");
	precache_sound ("demon/djump.wav");
	precache_sound ("demon/dpain1.wav");
	precache_sound ("demon/idle1.wav");
	precache_sound ("demon/sight2.wav");

	self.solid = SOLID_SLIDEBOX;
	self.movetype = MOVETYPE_STEP;

	setmodel (self, "progs/raptor.mdl");

//	setsize (self, VEC_HULL_MIN, VEC_HULL_MAX);
	setsize (self, '-16 -16 -24', '16 16 24');

	if (cvar("skill") == 3)
	    self.health = 250;
	else if (cvar("skill") == 2)
	    self.health = 150;
    else if (cvar("skill") == 1)
	    self.health = 75;
    else
	    self.health = 50;

	self.th_stand = demon1_stand1;
	self.th_walk = demon1_walk1;
	self.th_run = demon1_run1;
	self.th_die = demon_die;
	self.th_melee = Demon_MeleeAttack;		// one of two attacks
	self.th_missile = demon1_jump1;			// jump attack
	self.th_pain = demon1_pain;
		
	walkmonster_start();
};


/*
==============================================================================

DEMON

==============================================================================
*/

/*
==============
CheckDemonMelee

Returns TRUE if a melee attack would hit right now
==============
*/
float()	CheckDemonMelee =
{
	if (enemy_range == RANGE_MELEE)
	{	// FIXME: check canreach
		self.attack_state = AS_MELEE;
		return TRUE;
	}
	return FALSE;
};

/*
==============
CheckDemonJump

==============
*/
float()	CheckDemonJump =
{
	local	vector	dist;
	local	float	d;

	if (self.origin_z + self.mins_z > self.enemy.origin_z + self.enemy.mins_z
	+ 0.75 * self.enemy.size_z)
		return FALSE;
		
	if (self.origin_z + self.maxs_z < self.enemy.origin_z + self.enemy.mins_z
	+ 0.25 * self.enemy.size_z)
		return FALSE;
		
	dist = self.enemy.origin - self.origin;
	dist_z = 0;
	
	d = vlen(dist);
	
	if (d < 100)
		return FALSE;
		
	if (d > 150)
	{
		if (random() < 0.9)
			return FALSE;
	}
		
	return TRUE;
};

float()	DemonCheckAttack =
{
	local	vector	vec;
	
// if close enough for slashing, go for it
	if (CheckDemonMelee ())
	{
		self.attack_state = AS_MELEE;
		return TRUE;
	}
	
	if (CheckDemonJump ())
	{
		self.attack_state = AS_MISSILE;
        sound (self, CHAN_VOICE, "demon/djump.wav", 1, ATTN_NORM);
		return TRUE;
	}
	
	return FALSE;
};


//===========================================================================

void(float side)	Demon_Melee =
{
	local	float	ldmg;
	local vector	delta;
	
	ai_face ();
	walkmove (self.ideal_yaw, 20);	// allow a little closing

	delta = self.enemy.origin - self.origin;

	if (vlen(delta) > 100)
		return;
	if (!CanDamage (self.enemy, self))
		return;
		
    sound (self, CHAN_WEAPON, "demon/dhit2.wav", 1, ATTN_NORM);

	if(skill == 3)
		ldmg = 10 + 5*random();
	else if(skill == 2)
		ldmg = 7 + 5*random();
	else if(skill == 1)
		ldmg = 5 + 5*random();
	else
		ldmg = 2 + 5*random();

	T_Damage (self.enemy, self, self, ldmg);	

	makevectors (self.angles);
	SpawnMeatSpray (self.origin + v_forward*8, side * v_right);
};


void()	Demon_JumpTouch =
{
	local	float	ldmg;

	if (self.health <= 0)
		return;
		
	if (other.takedamage)
	{
		if ( vlen(self.velocity) > 400 )
		{
			ldmg = 20 + 10*random();
			T_Damage (other, self, self, ldmg);	
		}
	}

	if (!checkbottom(self))
	{
		if (self.flags & FL_ONGROUND)
		{	// jump randomly to not get hung up
//dprint ("popjump\n");
	self.touch = SUB_Null;
	self.think = demon1_jump1;
	self.nextthink = time + 0.1;

//			self.velocity_x = (random() - 0.5) * 600;
//			self.velocity_y = (random() - 0.5) * 600;
//			self.velocity_z = 200;
//			self.flags = self.flags - FL_ONGROUND;
		}
		return;	// not on ground yet
	}

	self.touch = SUB_Null;
//	self.think = demon1_jump12;
	self.think = demon1_run1;
	self.nextthink = time + 0.1;
};

