void(float damage, entity targ) spawn_touchblood;		//Prototype

//================================
//	CASE EJECTION
//================================
void () case_touch = 
{
    if (other.classname == "door")
    {
        SUB_Remove ();
        return;
    }

    sound (self,CHAN_AUTO,"weapons/case.wav",1,ATTN_NORM);
};

void (vector org, vector dir) eject_case = 
{
   	local float r;
   	local string temp;
   	r = random();

	newmis = spawn ();
	newmis.owner = self;
   	newmis.movetype = MOVETYPE_BOUNCE;
   	newmis.solid = SOLID_BBOX;
   	newmis.angles = vectoangles (dir);
   	newmis.classname = "Bullet Casing";
   	newmis.touch = case_touch;
        newmis.think = SUB_Remove;

	if (self.weapon == IT_SUPER_SHOTGUN)
	{
		setmodel (newmis,"progs/shell.mdl");
		newmis.nextthink = (time + 5);
	}
	else if (self.weapon == IT_SHOTGUN)
	{
   		setmodel (newmis,"progs/p_case.mdl");
   		newmis.nextthink = (time + 4);
	}
	else if (self.weapon == IT_UZI)
	{
   		setmodel (newmis,"progs/p_case.mdl");
   		newmis.nextthink = (time + 2);
	}
	else
	{
   		setmodel (newmis,"progs/case.mdl");
   		newmis.nextthink = (time + 2);
	}

	setsize (newmis,VEC_ORIGIN,VEC_ORIGIN);
   	setorigin (newmis,org);

    newmis.avelocity_x = (r * 3000);
    newmis.avelocity_y = (r * 3000);
	
   	if ((r < 0.100) && (r >= MSG_BROADCAST))  
	{
		newmis.velocity = (((v_forward * 20.000) + (v_right * 60.000)) + (v_up * 80.000));
	}
	if ((r < 0.200) && (r >= 0.100)) 
	{
	      newmis.velocity = (((v_forward * SVC_INTERMISSION) + (v_right * 65.000)) + (v_up * 90.000));
   	}
   	if ((r < 0.300) && (r >= 0.200)) 
	{
	      newmis.velocity = (((v_forward * 25.000) + (v_right * 70.000)) + (v_up * 100.000));
   	}
   	if ((r < 0.400) && (r >= 0.300)) 
	{
		newmis.velocity = (((v_forward * 15.000) + (v_right * 75.000)) + (v_up * 110.000));
	}
   	if ((r < 0.500) && (r >= 0.400))  
	{
	      newmis.velocity = (((v_forward * 25.000) + (v_right * 80.000)) + (v_up * 130.000));
	}	
	if ((r < 0.600) && (r >= 0.500))
	{
	      newmis.velocity = (((v_forward * 20.000) + (v_right * 85.000)) + (v_up * 150.000));
	}
	if ((r < 0.700) && (r >= 0.600))
	{
	      newmis.velocity = (((v_forward * TE_LAVASPLASH) + (v_right * 90.000)) + (v_up * 120.000));
	}
   	if ((r < 0.800) && (r >= 0.700)) 
	{
	      newmis.velocity = (((v_forward * 20.000) + (v_right * 100.000)) + (v_up * 200.000));
	}
	if ((r < 0.900) && (r >= 0.800))  
	{
	      newmis.velocity = (((v_forward * SVC_INTERMISSION) + (v_right * 110.000)) + (v_up * 130.000));
	}
	if ((r <= 2) && (r >= 0.900)) 
	{
	      newmis.velocity = (((v_forward * 25.000) + (v_right * 105.000)) + (v_up * 175.000));
	}
};
