// matrix projectile location damage
float LOC_HEAD				= 0;
float LOC_HEAD_BACK			= 1;
float LOC_TORSO	   			= 2;
float LOC_TORSO_BACK		= 3;
float LOC_STOMACH			= 4;
float LOC_STOMACH_BACK		= 5;
float LOC_GROIN  			= 6;
float LOC_GROIN_BACK		= 7;
float LOC_LEGS				= 8;
float LOC_LEGS_BACK			= 9;
float LOC_FEET				= 10;
float LOC_FEET_BACK			= 11;

// deathmatch flags
float DM_RESPAWN			= 1;
float DM_WEAPONS_STAY		= 2;
float DM_PISTOLS			= 4;
float DM_AUTOMATICS			= 8;
float DM_SHOTGUNS			= 16;
float DM_EXPLOSIVES			= 32;
float DM_SNIPERS			= 64;
float DM_EXIT_NON_FATAL		= 128;
float DM_INFINITE_AMMO		= 256;
float DM_ALL_WEAPONS		= 512;
float DM_NO_RELOAD			= 1024;
float DM_NO_ARMOR			= 2048;
float DM_NO_HEALTH			= 4096;
float DM_ARMOR_REGEN		= 8192;
float DM_HEALTH_REGEN		= 16384;
float DM_SAFE_SPAWN			= 32768;
float DM_NO_BOTS			= 65536;

// This mask includes the DM_* bits which indicates that the game is in
// an actual deathmatch mode.  Bits other than these make sense in
// single player or coop mode.
//
// 1 + 2 + 4 + 64
float DM_DM_MASK = 39679;
float AQS_SPAWN_PROTECT = 1;
float	SPAWN_PROTECT_DURATION = 5;
.float aqstate;

.float 		items2;
.float		ammo_shells1, ammo_nails1, ammo_rockets1, ammo_cells1;

void(entity theEntity) UpdateAmmoCounts;

.float semi;
.float nextframe;

//.float has_cross;

.float reload;
.float zoom;
.float zoomtoggle;

.float ammo_50cal;

.float bulletclip;
.float shellclip;
.float rifleclip;
.float uziclip;

.float	idupdate;
.float  regen_health;
.float  regen_armor;
//.vector camview;
//.float ccamera;
//.vector	neworigin;

// Constants for ambient_bgm
float BGM_START_ON	= 1;

// ladder stuff
.float fwatershift;
.float fwatershifttime;
.float laddertime;
.float ladderjump;
.float zerogtime;
