/*
==============================================================================

T-Rex

==============================================================================
*/


$cd id1/models/trex
$scale	1
$origin 0 0 24
$base base
$skin base

$frame Idle1 Idle2 Idle3 Idle4 Idle5 Idle6 Idle7 Idle8 Idle9 Idle10
$frame Idle11 Idle12 Idle13 Idle14 Idle15 Idle16 Idle17 Idle18 Idle19 Idle20

$frame IdleRoar1 IdleRoar2 IdleRoar3 IdleRoar4 IdleRoar5 IdleRoar6 IdleRoar7 IdleRoar8 IdleRoar9 IdleRoar10
$frame IdleRoar11 IdleRoar12 IdleRoar13 IdleRoar14 IdleRoar15 IdleRoar16 IdleRoar17 IdleRoar18 IdleRoar19 IdleRoar20
$frame IdleRoar21 IdleRoar22 IdleRoar23 IdleRoar24 IdleRoar25 IdleRoar26 IdleRoar27 IdleRoar28

$frame IdleBite1 IdleBite2 IdleBite3 IdleBite4 IdleBite5 IdleBite6 IdleBite7 IdleBite8 IdleBite9 IdleBite10
$frame IdleBite11 IdleBite12

$frame IdleBite2_1 IdleBite2_2 IdleBite2_3 IdleBite2_4 IdleBite2_5 IdleBite2_6 IdleBite2_7 IdleBite2_8 IdleBite2_9 IdleBite2_10
$frame IdleBite2_11 IdleBite2_12

$frame Walk1 Walk2 Walk3 Walk4 Walk5 Walk6 Walk7 Walk8
$frame Walk9 Walk10 Walk11 Walk12 Walk13 Walk14 Walk15
$frame Walk16 Walk17 Walk18 Walk19 Walk20 Walk21 Walk22
$frame Walk23 Walk24 Walk25 Walk26 Walk27 Walk28 Walk29 Walk30

$frame WalkRoar1 WalkRoar2 WalkRoar3 WalkRoar4 WalkRoar5 WalkRoar6 WalkRoar7 WalkRoar8
$frame WalkRoar9 WalkRoar10 WalkRoar11 WalkRoar12 WalkRoar13 WalkRoar14 WalkRoar15
$frame WalkRoar16 WalkRoar17 WalkRoar18 WalkRoar19 WalkRoar20

$frame WalkBite1 WalkBite2 WalkBite3 WalkBite4 WalkBite5 WalkBite6 WalkBite7 WalkBite8
$frame WalkBite9 WalkBite10 WalkBite11 WalkBite12 WalkBite13 WalkBite14 WalkBite15
$frame WalkBite16 WalkBite17 WalkBite18 WalkBite19 WalkBite20 WalkBite21 WalkBite22
$frame WalkBite23

$frame Pain1 Pain2 Pain3 Pain4 Pain5 Pain6 Pain7 Pain8 Pain9 Pain10 Pain11

$frame Pain2_1 Pain2_2 Pain2_3 Pain2_4 Pain2_5 Pain2_6 Pain2_7 Pain2_8

$frame Death1 Death2 Death3 Death4 Death5 Death6 Death7 Death8 Death9
$frame Death10 Death11 Death12 Death13 Death14 Death15 Death16 Death17 Death18 Death19 Death20

//============================================================================

void()  Rex_walk1;

void()	Rex_stand1	=[	$Idle1,	Rex_stand2	] {ai_stand();};
void()	Rex_stand2	=[	$Idle2,	Rex_stand3	] {ai_stand();};
void()	Rex_stand3	=[	$Idle3,	Rex_stand4	] {ai_stand();};
void()	Rex_stand4	=[	$Idle4,	Rex_stand5	] {ai_stand();};
void()	Rex_stand5	=[	$Idle5,	Rex_stand6	] {ai_stand();};
void()	Rex_stand6	=[	$Idle6,	Rex_stand7	] {ai_stand();};
void()	Rex_stand7	=[	$Idle7,	Rex_stand8	] {ai_stand();};
void()	Rex_stand8	=[	$Idle8,	Rex_stand9	] {ai_stand();};
void()	Rex_stand9	=[	$Idle9,	Rex_stand10	] {ai_stand();};
void()	Rex_stand10	=[	$Idle10,Rex_stand11	] {ai_stand();};
void()	Rex_stand11	=[	$Idle11,Rex_stand12	] {ai_stand();};
void()	Rex_stand12	=[	$Idle12,Rex_stand13	] {ai_stand();};
void()	Rex_stand13	=[	$Idle13,Rex_stand14	] {ai_stand();};
void()	Rex_stand14	=[	$Idle14,Rex_stand15	] {ai_stand();};
void()	Rex_stand15	=[	$Idle15,Rex_stand16	] {ai_stand();};
void()	Rex_stand16	=[	$Idle16,Rex_stand17	] {ai_stand();};
void()	Rex_stand17	=[	$Idle17,Rex_stand18	] {ai_stand();};
void()	Rex_stand18	=[	$Idle18,Rex_stand19	] {ai_stand();};
void()	Rex_stand19	=[	$Idle19,Rex_stand20	] {ai_stand();};
void()	Rex_stand20	=[	$Idle20,Rex_stand1	] {ai_stand();};

void()	Rex_standRoar1	=[	$IdleRoar1,	Rex_standRoar2	] {ai_turn();};
void()	Rex_standRoar2	=[	$IdleRoar2,	Rex_standRoar3	] {ai_turn();};
void()	Rex_standRoar3	=[	$IdleRoar3,	Rex_standRoar4	] {ai_turn();};
void()	Rex_standRoar4	=[	$IdleRoar4,	Rex_standRoar5	] {ai_turn();};
void()	Rex_standRoar5	=[	$IdleRoar5,	Rex_standRoar6	] {ai_turn();};
void()	Rex_standRoar6	=[	$IdleRoar6,	Rex_standRoar7	] {ai_turn();};
void()	Rex_standRoar7	=[	$IdleRoar7,	Rex_standRoar8	] {ai_turn();};
void()	Rex_standRoar8	=[	$IdleRoar8,	Rex_standRoar9	] {ai_turn();};
void()	Rex_standRoar9	=[	$IdleRoar9,	Rex_standRoar10	] {ai_turn();};
void()	Rex_standRoar10	=[	$IdleRoar10,Rex_standRoar11	] {ai_turn();};
void()	Rex_standRoar11	=[	$IdleRoar11,Rex_standRoar12	] {ai_turn();};
void()	Rex_standRoar12	=[	$IdleRoar12,Rex_standRoar13	] {ai_turn();};
void()	Rex_standRoar13	=[	$IdleRoar13,Rex_standRoar14	] {ai_turn();};
void()	Rex_standRoar14	=[	$IdleRoar14,Rex_standRoar15	] {ai_turn();};
void()	Rex_standRoar15	=[	$IdleRoar15,Rex_standRoar16	] {ai_turn();};
void()	Rex_standRoar16	=[	$IdleRoar16,Rex_standRoar17	] {ai_turn();};
void()	Rex_standRoar17	=[	$IdleRoar17,Rex_standRoar18	] {ai_turn();};
void()	Rex_standRoar18	=[	$IdleRoar18,Rex_standRoar19	] {ai_turn();};
void()	Rex_standRoar19	=[	$IdleRoar19,Rex_standRoar20	] {ai_turn();};
void()	Rex_standRoar20	=[	$IdleRoar20,Rex_standRoar21	] {ai_turn();};
void()	Rex_standRoar21	=[	$IdleRoar21,Rex_standRoar22	] {ai_turn();};
void()	Rex_standRoar22	=[	$IdleRoar22,Rex_standRoar23	] {ai_turn();};
void()	Rex_standRoar23	=[	$IdleRoar23,Rex_standRoar24	] {ai_turn();};
void()	Rex_standRoar24	=[	$IdleRoar24,Rex_standRoar25	] {ai_turn();};
void()	Rex_standRoar25	=[	$IdleRoar25,Rex_standRoar26	] {ai_turn();};
void()	Rex_standRoar26	=[	$IdleRoar26,Rex_standRoar27	] {ai_turn();};
void()	Rex_standRoar27	=[	$IdleRoar27,Rex_standRoar28	] {ai_turn();};
void()	Rex_standRoar28	=[	$IdleRoar28,Rex_standRoar1	] {ai_turn();};

void()	Rex_standBite1	=[	$IdleBite1,	Rex_standBite2	] {ai_face ();};
void()	Rex_standBite2	=[	$IdleBite2,	Rex_standBite3	] {};
void()	Rex_standBite3	=[	$IdleBite3,	Rex_standBite4	] {};
void()	Rex_standBite4	=[	$IdleBite4,	Rex_standBite5	] {};
void()	Rex_standBite5	=[	$IdleBite5,	Rex_standBite6	] {};
void()	Rex_standBite6	=[	$IdleBite6,	Rex_standBite7	] {};
void()	Rex_standBite7	=[	$IdleBite7,	Rex_standBite8	] {};
void()	Rex_standBite8	=[	$IdleBite8,	Rex_standBite9	] {Rex_Melee(200);};
void()	Rex_standBite9	=[	$IdleBite9,	Rex_standBite10	] {};
void()	Rex_standBite10	=[	$IdleBite10,Rex_standBite11	] {};
void()	Rex_standBite11	=[	$IdleBite11,Rex_standBite12	] {};
void()	Rex_standBite12	=[	$IdleBite12,Rex_walk1		] {};

void()	Rex_standBite2_1	=[	$IdleBite2_1,	Rex_standBite2_2	] {ai_face ();};
void()	Rex_standBite2_2	=[	$IdleBite2_2,	Rex_standBite2_3	] {};
void()	Rex_standBite2_3	=[	$IdleBite2_3,	Rex_standBite2_4	] {};
void()	Rex_standBite2_4	=[	$IdleBite2_4,	Rex_standBite2_5	] {};
void()	Rex_standBite2_5	=[	$IdleBite2_5,	Rex_standBite2_6	] {};
void()	Rex_standBite2_6	=[	$IdleBite2_6,	Rex_standBite2_7	] {};
void()	Rex_standBite2_7	=[	$IdleBite2_7,	Rex_standBite2_8	] {Rex_Melee(-200);};
void()	Rex_standBite2_8	=[	$IdleBite2_8,	Rex_standBite2_9	] {};
void()	Rex_standBite2_9	=[	$IdleBite2_9,	Rex_standBite2_10	] {};
void()	Rex_standBite2_10	=[	$IdleBite2_10,	Rex_standBite2_11	] {};
void()	Rex_standBite2_11	=[	$IdleBite2_11,	Rex_standBite2_12	] {};
void()	Rex_standBite2_12	=[	$IdleBite2_12,	Rex_walk1			] {};

void()	Rex_walk1	=[	$Walk1,		Rex_walk2	] {ai_run(20);};
void()	Rex_walk2	=[	$Walk2,		Rex_walk3	] {ai_run(20);};
void()	Rex_walk3	=[	$Walk3,		Rex_walk4	] {ai_run(20);};
void()	Rex_walk4	=[	$Walk4,		Rex_walk5	] {ai_run(20);};
void()	Rex_walk5	=[	$Walk5,		Rex_walk6	] {ai_run(20);};
void()	Rex_walk6	=[	$Walk6,		Rex_walk7	] {ai_run(20);};
void()	Rex_walk7	=[	$Walk7,		Rex_walk8	] {ai_run(20);};
void()	Rex_walk8	=[	$Walk8,		Rex_walk9	] {ai_run(20);};
void()	Rex_walk9	=[	$Walk9,		Rex_walk10	] {ai_run(20);};
void()	Rex_walk10	=[	$Walk10,	Rex_walk11	] {ai_run(20);};
void()	Rex_walk11	=[	$Walk11,	Rex_walk12	] {ai_run(20);};
void()	Rex_walk12	=[	$Walk12,	Rex_walk13	] {ai_run(20);};
void()	Rex_walk13	=[	$Walk13,	Rex_walk14	] {ai_run(20);};
void()	Rex_walk14	=[	$Walk14,	Rex_walk15	] {ai_run(20);};
void()	Rex_walk15	=[	$Walk15,	Rex_walk16	] {ai_run(20);};
void()	Rex_walk16	=[	$Walk16,	Rex_walk17	] {ai_run(20);};
void()	Rex_walk17	=[	$Walk17,	Rex_walk18	] {ai_run(20);};
void()	Rex_walk18	=[	$Walk18,	Rex_walk19	] {ai_run(20);};
void()	Rex_walk19	=[	$Walk19,	Rex_walk20	] {ai_run(20);};
void()	Rex_walk20	=[	$Walk20,	Rex_walk21	] {ai_run(20);};
void()	Rex_walk21	=[	$Walk21,	Rex_walk22	] {ai_run(20);};
void()	Rex_walk22	=[	$Walk22,	Rex_walk23	] {ai_run(20);};
void()	Rex_walk23	=[	$Walk23,	Rex_walk24	] {ai_run(20);};
void()	Rex_walk24	=[	$Walk24,	Rex_walk25	] {ai_run(20);};
void()	Rex_walk25	=[	$Walk25,	Rex_walk26	] {ai_run(20);};
void()	Rex_walk26	=[	$Walk26,	Rex_walk27	] {ai_run(20);};
void()	Rex_walk27	=[	$Walk27,	Rex_walk28	] {ai_run(20);};
void()	Rex_walk28	=[	$Walk28,	Rex_walk29	] {ai_run(20);};
void()	Rex_walk29	=[	$Walk29,	Rex_walk30	] {ai_run(20);};
void()	Rex_walk30	=[	$Walk30,	Rex_walk1	] {ai_run(20);};

void()	Rex_walkRoar1	=[	$WalkRoar1,		Rex_walkRoar2	] {ai_walk(20);};
void()	Rex_walkRoar2	=[	$WalkRoar2,		Rex_walkRoar3	] {ai_walk(20);};
void()	Rex_walkRoar3	=[	$WalkRoar3,		Rex_walkRoar4	] {ai_walk(20);};
void()	Rex_walkRoar4	=[	$WalkRoar4,		Rex_walkRoar5	] {ai_walk(20);};
void()	Rex_walkRoar5	=[	$WalkRoar5,		Rex_walkRoar6	] {ai_walk(20);};
void()	Rex_walkRoar6	=[	$WalkRoar6,		Rex_walkRoar7	] {ai_walk(20);};
void()	Rex_walkRoar7	=[	$WalkRoar7,		Rex_walkRoar8	] {ai_walk(20);};
void()	Rex_walkRoar8	=[	$WalkRoar8,		Rex_walkRoar9	] {ai_walk(20);};
void()	Rex_walkRoar9	=[	$WalkRoar9,		Rex_walkRoar10	] {ai_walk(20);};
void()	Rex_walkRoar10	=[	$WalkRoar10,	Rex_walkRoar11	] {ai_walk(20);};
void()	Rex_walkRoar11	=[	$WalkRoar11,	Rex_walkRoar12	] {ai_walk(20);};
void()	Rex_walkRoar12	=[	$WalkRoar12,	Rex_walkRoar13	] {ai_walk(20);};
void()	Rex_walkRoar13	=[	$WalkRoar13,	Rex_walkRoar14	] {ai_walk(20);};
void()	Rex_walkRoar14	=[	$WalkRoar14,	Rex_walkRoar15	] {ai_walk(20);};
void()	Rex_walkRoar15	=[	$WalkRoar15,	Rex_walkRoar16	] {ai_walk(20);};
void()	Rex_walkRoar16	=[	$WalkRoar16,	Rex_walkRoar17	] {ai_walk(20);};
void()	Rex_walkRoar17	=[	$WalkRoar17,	Rex_walkRoar18	] {ai_walk(20);};
void()	Rex_walkRoar18	=[	$WalkRoar18,	Rex_walkRoar19	] {ai_walk(20);};
void()	Rex_walkRoar19	=[	$WalkRoar19,	Rex_walkRoar20	] {ai_walk(20);};
void()	Rex_walkRoar20	=[	$WalkRoar20,	Rex_walk1		] {ai_walk(20);};

void()	Rex_walkBite1	=[	$WalkBite1,		Rex_walkBite2	] {ai_face();};
void()	Rex_walkBite2	=[	$WalkBite2,		Rex_walkBite3	] {ai_walk(20);};
void()	Rex_walkBite3	=[	$WalkBite3,		Rex_walkBite4	] {ai_walk(20);};
void()	Rex_walkBite4	=[	$WalkBite4,		Rex_walkBite5	] {ai_walk(20);};
void()	Rex_walkBite5	=[	$WalkBite5,		Rex_walkBite6	] {ai_walk(20);};
void()	Rex_walkBite6	=[	$WalkBite6,		Rex_walkBite7	] {ai_walk(20);};
void()	Rex_walkBite7	=[	$WalkBite7,		Rex_walkBite8	] {ai_walk(20);};
void()	Rex_walkBite8	=[	$WalkBite8,		Rex_walkBite9	] {ai_walk(20);};
void()	Rex_walkBite9	=[	$WalkBite9,		Rex_walkBite10	] {ai_walk(20);};
void()	Rex_walkBite10	=[	$WalkBite10,	Rex_walkBite11	] {ai_walk(20);};
void()	Rex_walkBite11	=[	$WalkBite11,	Rex_walkBite12	] {ai_walk(20);};
void()	Rex_walkBite12	=[	$WalkBite12,	Rex_walkBite13	] {ai_walk(20);};
void()	Rex_walkBite13	=[	$WalkBite13,	Rex_walkBite14	] {ai_walk(20);Rex_Melee(200);};
void()	Rex_walkBite14	=[	$WalkBite14,	Rex_walkBite15	] {ai_walk(20);};
void()	Rex_walkBite15	=[	$WalkBite15,	Rex_walkBite16	] {ai_walk(20);};
void()	Rex_walkBite16	=[	$WalkBite16,	Rex_walkBite17	] {ai_walk(20);};
void()	Rex_walkBite17	=[	$WalkBite17,	Rex_walkBite18	] {ai_walk(20);};
void()	Rex_walkBite18	=[	$WalkBite18,	Rex_walkBite19	] {ai_walk(20);};
void()	Rex_walkBite19	=[	$WalkBite19,	Rex_walkBite20	] {ai_walk(20);};
void()	Rex_walkBite20	=[	$WalkBite20,	Rex_walkBite21	] {ai_walk(20);};
void()	Rex_walkBite21	=[	$WalkBite21,	Rex_walkBite22	] {ai_walk(20);};
void()	Rex_walkBite22	=[	$WalkBite22,	Rex_walkBite23	] {ai_walk(20);};
void()	Rex_walkBite23	=[	$WalkBite23,	Rex_walkRoar1	] {ai_walk(20);};

void()	Rex_pain1	=[	$Pain1,		Rex_pain2	] {};
void()	Rex_pain2	=[	$Pain2,		Rex_pain3	] {};
void()	Rex_pain3	=[	$Pain3,		Rex_pain4	] {};
void()	Rex_pain4	=[	$Pain4,		Rex_pain5	] {};
void()	Rex_pain5	=[	$Pain5,		Rex_pain6	] {};
void()	Rex_pain6	=[	$Pain6,		Rex_pain7	] {};
void()	Rex_pain7	=[	$Pain7,		Rex_pain8	] {};
void()	Rex_pain8	=[	$Pain8,		Rex_pain9	] {};
void()	Rex_pain9	=[	$Pain9,		Rex_pain10	] {};
void()	Rex_pain10	=[	$Pain10,	Rex_pain11	] {};
void()	Rex_pain11	=[	$Pain11,	Rex_walkRoar1	] {};

void()	Rex_pain2_1	=[	$Pain2_1,	Rex_pain2_2	] {};
void()	Rex_pain2_2	=[	$Pain2_2,	Rex_pain2_3	] {};
void()	Rex_pain2_3	=[	$Pain2_3,	Rex_pain2_4	] {};
void()	Rex_pain2_4	=[	$Pain2_4,	Rex_pain2_5	] {};
void()	Rex_pain2_5	=[	$Pain2_5,	Rex_pain2_6	] {};
void()	Rex_pain2_6	=[	$Pain2_6,	Rex_pain2_7	] {};
void()	Rex_pain2_7	=[	$Pain2_7,	Rex_pain2_8	] {};
void()	Rex_pain2_8	=[	$Pain2_8,	Rex_walk1	] {};

void(entity attacker, float damage)	Rex_pain =
{
	if (self.pain_finished > time)
		return;

	self.pain_finished = time + 1;
    sound (self, CHAN_VOICE, "demon/dpain1.wav", 1, ATTN_NORM);

	if (random()*200 > damage)
		return;		// didn't flinch

	if (random() < 0.5)
		Rex_pain1 ();
	else
		Rex_pain2_1 ();
};

void()	Rex_die1		=[	$Death1,		Rex_die2	] {
sound (self, CHAN_VOICE, "demon/ddeath.wav", 1, ATTN_NORM);};
void()	Rex_die2		=[	$Death2,		Rex_die3	] {self.solid = SOLID_NOT;};
void()	Rex_die3		=[	$Death3,		Rex_die4	] {};
void()	Rex_die4		=[	$Death4,		Rex_die5	] {};
void()	Rex_die5		=[	$Death5,		Rex_die6	] {};
void()	Rex_die6		=[	$Death6,		Rex_die7	] {};
void()	Rex_die7		=[	$Death7,		Rex_die8	] {};
void()	Rex_die8		=[	$Death8,		Rex_die9	] {};
void()	Rex_die9		=[	$Death9,		Rex_die10 	] {};
void()	Rex_die10		=[	$Death10,		Rex_die11	] {};
void()	Rex_die11		=[	$Death11,		Rex_die12	] {};
void()	Rex_die12		=[	$Death12,		Rex_die13	] {};
void()	Rex_die13		=[	$Death13,		Rex_die14	] {};
void()	Rex_die14		=[	$Death14,		Rex_die15	] {};
void()	Rex_die15		=[	$Death15,		Rex_die16	] {};
void()	Rex_die16		=[	$Death16,		Rex_die17	] {};
void()	Rex_die17		=[	$Death17,		Rex_die18	] {};
void()	Rex_die18		=[	$Death18,		Rex_die19	] {};
void()	Rex_die19		=[	$Death19,		Rex_die20 	] {};
void()	Rex_die20		=[	$Death20,		Rex_die20 	] {};

void() 	Rex_die =
{
// check for gib
	if (self.health < -1000)
	{
		if (damage_attacker.weapon == IT_ROCKET_LAUNCHER ||
			damage_attacker.weapon == IT_GRENADE_LAUNCHER ||
			damage_attacker.weapon == IT_LIGHTNING)
		{
			sound (self, CHAN_VOICE, "player/udeath.wav", 1, ATTN_NORM);
//			ThrowHead ("progs/h_demon.mdl", self.health);
			ThrowHead ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			ThrowGib ("progs/gib1.mdl", self.health);
			return;
		}
	}

// regular death
	Rex_die1 ();
};

void() Rex_MeleeAttack =
{
	if (random() < 0.50)
		Rex_standBite1 ();
	else
		Rex_standBite2_1 ();
};

void() Rex_StandSelect =
{
//	if (random() < 0.75)
		Rex_stand1 ();
//	else
//		Rex_standRoar1 ();
};

void() Rex_WalkSelect =
{
	if (random() < 0.75)
		Rex_walk1 ();
	else
		Rex_walkRoar1 ();
};

void() Rex_WalkBiteSelect =
{
	if (random() < 0.75)
		Rex_walkBite1 ();
	else
		Rex_standRoar1 ();
};

/*QUAKED monster_rex (1 0 0) (-32 -32 -24) (32 32 64) Ambush

*/
void() monster_rex =
{
	if (deathmatch & DM_DM_MASK)
	{
		remove(self);
		return;
	}

	precache_model ("progs/trex.mdl");

	precache_sound ("demon/ddeath.wav");
	precache_sound ("demon/dhit2.wav");
	precache_sound ("demon/djump.wav");
	precache_sound ("demon/dpain1.wav");
	precache_sound ("demon/idle1.wav");
	precache_sound ("demon/sight2.wav");

	self.solid = SOLID_SLIDEBOX;
	self.movetype = MOVETYPE_STEP;

	setmodel (self, "progs/trex.mdl");

//	setsize (self, VEC_HULL2_MIN, VEC_HULL2_MAX);
	setsize (self, '-32 -32 -16', '32 32 128');
//	setsize (self, '-16 -16 -24', '16 16 24');

	if (cvar("skill") == 3)
	    self.health = 5000;
	else if (cvar("skill") == 2)
	    self.health = 3500;
    else if (cvar("skill") == 1)
	    self.health = 2000;
    else
	    self.health = 1000;

	self.th_stand = Rex_StandSelect;
	self.th_walk = Rex_WalkSelect;
	self.th_run = Rex_WalkSelect;
	self.th_die = Rex_die;
	self.th_melee = Rex_MeleeAttack;		// one of two attacks
	self.th_missile = Rex_WalkBiteSelect;			// jump attack
	self.th_pain = Rex_pain;

	walkmonster_start();
};


/*
==============================================================================

Rex

==============================================================================
*/

/*
==============
CheckRexMelee

Returns TRUE if a melee attack would hit right now
==============
*/
float()	CheckRexMelee =
{
	if (enemy_range == RANGE_MELEE)
	{	// FIXME: check canreach
		self.attack_state = AS_MELEE;
		return TRUE;
	}
	return FALSE;
};

/*
==============
CheckRexWalkBite

==============
*/
float()	CheckRexWalkBite =
{
	local	vector	dist;
	local	float	d;

	if (self.origin_z + self.mins_z > self.enemy.origin_z + self.enemy.mins_z
	+ 0.75 * self.enemy.size_z)
		return FALSE;

	if (self.origin_z + self.maxs_z < self.enemy.origin_z + self.enemy.mins_z
	+ 0.25 * self.enemy.size_z)
		return FALSE;

	dist = self.enemy.origin - self.origin;
	dist_z = 0;

	d = vlen(dist);

	if (d < 32)
		return FALSE;

	if (d > 128)
		return FALSE;

	return TRUE;
};

float()	RexCheckAttack =
{
	local	vector	vec;

// if close enough for slashing, go for it
	if (CheckRexMelee ())
	{
		self.attack_state = AS_MELEE;
		return TRUE;
	}

	if (CheckRexWalkBite ())
	{
		self.attack_state = AS_MISSILE;
		return TRUE;
	}

	return FALSE;
};

//===========================================================================

void(float side)	Rex_Melee =
{
	local	float	ldmg;
	local vector	delta;

	ai_face ();
	walkmove (self.ideal_yaw, 20);	// allow a little closing

	delta = self.enemy.origin - self.origin;

	if (vlen(delta) > 100)
		return;
	if (!CanDamage (self.enemy, self))
		return;

    sound (self, CHAN_WEAPON, "demon/dhit2.wav", 1, ATTN_NORM);

	if(skill == 3)
		ldmg = 50 + 5*random();
	else if(skill == 2)
		ldmg = 30 + 5*random();
	else if(skill == 1)
		ldmg = 20 + 5*random();
	else
		ldmg = 10 + 5*random();

	T_Damage (self.enemy, self, self, ldmg);

	makevectors (self.angles);
	SpawnMeatSpray (self.origin + v_forward*8, side * v_right);
};
